<eui-page id="elis-result">
  <eui-page-content class="eui-u-flex">
    <eui-breadcrumb id="eui-breadcrumb">
      <eui-breadcrumb-item link="/screen/eliSearch" label="{{ 'elis.search.title' | translate }}"></eui-breadcrumb-item>
      <eui-breadcrumb-item link="/search" label="{{ 'elis.results.title' | translate }}"></eui-breadcrumb-item>
    </eui-breadcrumb>
    <div class="ecl-container">
      <div class="elis-disclaimer" [innerHTML]="'elis.disclaimer' | translate"></div>
      <h1>{{ 'elis.results.title' | translate }}</h1>

      <dl class="ecl-u-d-flex ecl-row" *ngIf="searchService.getSearchParams() as searchParams">
        <elis-metadata-details-link
          class="ecl-col-12"
          [countries]="searchService.getSearchParams().countries"
        ></elis-metadata-details-link>
      </dl>

      <div id="elis-sticky-panel" class="elis-sticky-panel">
        <div class="result-buttons ecl-u-d-flex">
          <div class="eui-u-p-s eui-u-flex eui-u-flex-justify-content-end">
            <button *ngIf="debug" euiButton (click)="debugSearch()" class="eui-u-mr-s" euiAccent>Debug search</button>
            <button euiButton (click)="modifySearch()" class="eui-u-mr-s">
              {{ 'elis.results.button.modifySearch' | translate }}
            </button>
            <button euiButton (click)="newSearch()" class="eui-u-mr-s" euiPrimary>
              {{ 'elis.results.button.newSearch' | translate }}
            </button>
          </div>
        </div>
      </div>

      <eui-page-columns>
        <eui-page-column
          [label]="'elis.results.facets.title' | translate"
          size="2xl"
          [isCollapsible]="true"
          *ngIf="results.length"
        >
          <eui-page-column-header-body>
            <span *ngIf="$selectedFacets().size > 0">{{ 'elis.results.facets.selected' | translate }}</span>
            <eui-chip-list isChipsRemovable (chipRemove)="onFacetRemove($event)">
              <eui-chip
                *ngFor="let selectedFacet of $selectedFacets()"
                [id]="selectedFacet.value"
                [data]="selectedFacet"
              >
                <span euiLabel>{{ selectedFacet.label }}</span>
              </eui-chip>
            </eui-chip-list>
          </eui-page-column-header-body>
          <eui-page-column-body>
            <div euiInputGroup class="eui-u-mb-m">
              <label euiLabel for="filter-text">{{ 'elis.results.facets.filterText' | translate }}</label>
              <div class="eui-input-group-addon">
                <input
                  euiInputText
                  id="filter-text"
                  name="filter-text"
                  placeholder="{{ 'elis.results.facets.filterTextPlaceholder' | translate }}"
                  [(ngModel)]="filterText"
                  (keyup.enter)="onFilterTextEntered()"
                />
                <button
                  euiButton
                  euiSecondary
                  euiIconButton
                  class="elis-action-button"
                  (buttonClick)="onFilterTextEntered()"
                >
                  <eui-icon-svg icon="eui-ecl-search" size="xs" fillColor="neutral-light"></eui-icon-svg>
                </button>
              </div>
            </div>
            <ul euiList *ngFor="let facetCategory of $facets() | keyvalue">
              <strong>{{ 'elis.results.facets.' + facetCategory.key | translate }}</strong>
              <li euiListItem *ngFor="let facet of facetCategory.value | keyvalue: originalOrder | slice: 0 : 5">
                <a
                  class="elis-facet-link"
                  (click)="onFacetItemClick(facetCategory.key, facet.key)"
                  href="javascript:void(0)"
                  ><span>{{ facet.key | facetLabel: facetCategory.key }} ({{ facet.value }})</span></a
                >
              </li>
              <select
                euiSelect
                (change)="onFacetItemClickSelect(facetCategory.key, $event)"
                *ngIf="facetCategory.value.size > 5"
              >
                <option [value]="">{{ 'elis.results.facets.seeMore.' + facetCategory.key | translate }}</option>
                <option
                  *ngFor="let facet of facetCategory.value | keyvalue: originalOrder | slice: 5"
                  [value]="facet.key"
                >
                  {{ facet.key | facetLabel: facetCategory.key }} ({{ facet.value }})
                </option>
              </select>
            </ul>
          </eui-page-column-body>
        </eui-page-column>

        <eui-page-column>
          <eui-page-column-body>
            <div *ngIf="searchService.getSearchParams() as searchParams">
              <h2 class="eui-u-mt-xs">{{ 'elis.results.criteria.title' | translate }}</h2>
              <dl class="ecl-u-d-flex ecl-row">
                <div class="ecl-col-12"></div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.countries">
                  <dt>{{ 'elis.results.criteria.country' | translate }}</dt>
                  <dd *ngIf="searchParams.countries.length > 0">
                    <ng-container *ngFor="let country of searchParams.countries; last as last"
                      >{{ 'elis.country.' + country | translate
                      }}<ng-container *ngIf="!last">,&nbsp;</ng-container></ng-container
                    >
                  </dd>
                  <dd *ngIf="searchParams.countries.length === 0">
                    {{ 'elis.search.criteria.country.allCountries' | translate }}
                  </dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.NatActURI">
                  <dt>{{ 'elis.results.criteria.NatActURI' | translate }}</dt>
                  <dd>{{ searchParams.NatActURI }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.relation">
                  <dt>{{ 'elis.results.criteria.relation' | translate }}</dt>
                  <dd *ngIf="searchParams.relation !== 'ANY'">{{ searchParams.relation }}</dd>
                  <dd *ngIf="searchParams.relation === 'ANY'">{{ 'elis.common.any' | translate }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.dateType">
                  <dt>{{ 'elis.results.criteria.dateType' | translate }}</dt>
                  <dd>{{ searchParams.dateType }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.dateFrom">
                  <dt>
                    {{
                      (searchParams.dateTo ? 'elis.results.criteria.dateFrom' : 'elis.results.criteria.date')
                        | translate
                    }}
                  </dt>
                  <dd>{{ searchParams.dateFrom | date }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.dateTo">
                  <dt>{{ 'elis.results.criteria.dateTo' | translate }}</dt>
                  <dd>{{ searchParams.dateTo | date }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.EUYear">
                  <dt>{{ 'elis.results.criteria.EUYear' | translate }}</dt>
                  <dd>{{ searchParams.EUYear }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.EUCelex">
                  <dt>{{ 'elis.results.criteria.EUCelex' | translate }}</dt>
                  <dd>{{ searchParams.EUCelex }}</dd>
                </div>
                <div class="ecl-col-12 ecl-col-l-6 ecl-u-pb-xs" *ngIf="searchParams.EUActURI">
                  <dt>{{ 'elis.results.criteria.EUActURI' | translate }}</dt>
                  <dd>{{ searchParams.EUActURI }}</dd>
                </div>
              </dl>
            </div>
            <form [formGroup]="$resultForm()" class="eui-u-mt-m eui-u-mb-m elis-sort-criteria-panel">
              <div class="eui-u-display-block eui-u-flex-row">
                <h2>{{ 'elis.results.tree.title' | translate }}</h2>
                <div class="ecl-row eui-u-mb-l">
                  <div class="ecl-col-12 ecl-col-m-6 elis-sort-explanation">
                    {{ 'elis.results.sort.explanation' | translate }}
                  </div>
                  <div id="primary" class="ecl-col-6 ecl-col-m-3">
                    <label euiLabel for="primary-select">{{ 'elis.results.sort.primary' | translate }}</label>
                    <select euiSelect name="primary-select" id="primary-select" formControlName="primary">
                      <option value="country-asc">{{ 'elis.results.sort.country' | translate }}</option>
                      <option value="date_publication-asc">{{ 'elis.results.sort.dateAscending' | translate }}</option>
                      <option value="date_publication-desc">
                        {{ 'elis.results.sort.dateDescending' | translate }}
                      </option>
                      <option value="relation-asc">{{ 'elis.results.sort.relation' | translate }}</option>
                    </select>
                  </div>
                  <div id="secondary" class="ecl-col-6 ecl-col-m-3">
                    <label euiLabel for="secondary-select">{{ 'elis.results.sort.secondary' | translate }}</label>
                    <select euiSelect name="secondary-select" id="secondary-select" formControlName="secondary">
                      <option value="country-asc">{{ 'elis.results.sort.country' | translate }}</option>
                      <option value="date_publication-asc">{{ 'elis.results.sort.dateAscending' | translate }}</option>
                      <option value="date_publication-desc">
                        {{ 'elis.results.sort.dateDescending' | translate }}
                      </option>
                      <option value="relation-asc">{{ 'elis.results.sort.relation' | translate }}</option>
                    </select>
                  </div>
                </div>
                <elis-validation-message
                  *ngIf="$resultForm().controls.secondary?.errors?.sameCriteria"
                  [validationMessageKey]="'elis.results.sort.error.sameCriteria'"
                />
              </div>
            </form>

            <!--      classic infinite scroll view-->

            <!--      <div *ngIf="results.length" class="eui-u-flex eui-u-flex-column" elisInfiniteScroll (nearEnd)="onNearEndScroll()">-->
            <!--        <div class="elis-primary-group" *ngFor="let primary of $displayedData() | keyvalue: originalOrder">-->
            <!--          <h3>{{ getPrimaryDisplayValue(primary.key) }}</h3>-->
            <!--          <div-->
            <!--            class="elis-secondary-group ecl-u-pl-m"-->
            <!--            *ngFor="let secondary of primary.value | keyvalue: originalOrder"-->
            <!--          >-->
            <!--            <h4>{{ getSecondaryDisplayValue(secondary.key) }}</h4>-->
            <!--            <elis-result-item-->
            <!--              class="eui-u-width-100"-->
            <!--              *ngFor="let result of secondary.value"-->
            <!--              [result]="result"-->
            <!--              [columns]="columns"-->
            <!--            ></elis-result-item>-->
            <!--          </div>-->
            <!--        </div>-->
            <!--      </div>-->

            <!--              alternative tree view-->
            <!--      <eui-tree-list [isShowToolbar]="true" *ngIf="results.length">-->
            <!--        <eui-tree-list-item-->
            <!--          *ngFor="let primary of $displayedData() | keyvalue: originalOrder"-->
            <!--          label="{{ primary | treeNodeTitle: searchService.getPrimarySortingKey() }}"-->
            <!--        >-->
            <!--          <eui-tree-list>-->
            <!--            <eui-tree-list-item-->
            <!--              *ngFor="let secondary of primary.value | keyvalue: originalOrder"-->
            <!--              label="{{ secondary | treeNodeTitle: searchService.getSecondarySortingKey() }}"-->
            <!--            >-->
            <!--              <eui-tree-list>-->
            <!--                <eui-tree-list-item *ngFor="let result of secondary.value" label="{{ result?.title?.value }}">-->
            <!--                  <eui-tree-list-item-content>-->
            <!--                    <elis-result-item class="eui-u-width-100" [result]="result" [columns]="columns"></elis-result-item>-->
            <!--                  </eui-tree-list-item-content>-->
            <!--                </eui-tree-list-item>-->
            <!--              </eui-tree-list>-->
            <!--            </eui-tree-list-item>-->
            <!--          </eui-tree-list>-->
            <!--        </eui-tree-list-item>-->
            <!--      </eui-tree-list>-->

            <eui-tree-list
              *ngIf="results.length"
              [isExpanded]="$isExpanded()"
              [isShowToolbar]="true"
              (expandAll)="setExpanded(true)"
              (collapseAll)="setExpanded(false)"
            >
              <eui-tree-list-item
                *ngFor="let level1 of $displayedData() | keyvalue: originalOrder"
                label="{{ level1 | treeNodeTitle: resultService.getPrimarySortingKey() }}"
              >
                <eui-tree-list>
                  <eui-tree-list-item
                    *ngFor="let level2 of level1.value | keyvalue: originalOrder"
                    label="{{ level2 | treeNodeTitle: resultService.getSecondarySortingKey() }}"
                  >
                    <eui-tree-list>
                      <ng-container *ngIf="hasTertiaryLevel">
                        <eui-tree-list-item
                          *ngFor="let level3 of level2.value | keyvalue: originalOrder"
                          label="{{ level3 | treeNodeTitle: resultService.getTertiarySortingKey() }}"
                        >
                          <eui-tree-list>
                            <eui-tree-list-item *ngFor="let result of level3.value" label="{{ result?.title?.value }}">
                              <eui-tree-list-item-content>
                                <elis-result-item
                                  class="eui-u-width-100"
                                  [result]="result"
                                  [columns]="columns"
                                ></elis-result-item>
                              </eui-tree-list-item-content>
                            </eui-tree-list-item>
                          </eui-tree-list>
                        </eui-tree-list-item>
                      </ng-container>

                      <ng-container *ngIf="!hasTertiaryLevel">
                        <eui-tree-list-item *ngFor="let result of level2.value" label="{{ result?.title?.value }}">
                          <eui-tree-list-item-content>
                            <elis-result-item
                              class="eui-u-width-100"
                              [result]="result"
                              [columns]="columns"
                            ></elis-result-item>
                          </eui-tree-list-item-content>
                        </eui-tree-list-item>
                      </ng-container>
                    </eui-tree-list>
                  </eui-tree-list-item>
                </eui-tree-list>
              </eui-tree-list-item>
            </eui-tree-list>

            <div class="eui-u-display-flex eui-u-flex-column eui-u-width-100" *ngIf="searchService.isLoading()">
              <eui-skeleton rectangle class="eui-u-mt-xs"></eui-skeleton>
              <eui-skeleton line class="eui-u-mt-xs"></eui-skeleton>

              <eui-skeleton rectangle class="eui-u-mt-2xl"></eui-skeleton>
              <eui-skeleton line class="eui-u-mt-xs"></eui-skeleton>

              <eui-skeleton rectangle class="eui-u-mt-2xl"></eui-skeleton>
              <eui-skeleton line class="eui-u-mt-xs"></eui-skeleton>

              <eui-skeleton rectangle class="eui-u-mt-2xl"></eui-skeleton>
              <eui-skeleton line class="eui-u-mt-xs"></eui-skeleton>

              <eui-skeleton rectangle class="eui-u-mt-2xl"></eui-skeleton>
              <eui-skeleton line class="eui-u-mt-xs"></eui-skeleton>
            </div>
            <div class="eui-u-mt-m" *ngIf="!results.length && !searchService.isLoading()">
              {{ 'elis.results.noResults' | translate }}
            </div>
            <!--      <div class="eui-u-mt-m" *ngIf="endOfResults">{{ 'elis.results.endOfResults' | translate }}</div>-->
            <div class="eui-u-mt-m" *ngIf="limitOfResults">{{ 'elis.results.limitOfResults' | translate }}</div>
          </eui-page-column-body>
        </eui-page-column>
      </eui-page-columns>
    </div>
  </eui-page-content>
</eui-page>
